/* simple function to set ctcss tone */


#include "ft100.h"
#include <string.h>

char *tone_tbl[39]  = 
{ 
    "67.0",  "69.3",  "71.9",  "74.4",  "77.0",  "79.7", 
    "82.5",  "85.4",  "88.5",  "91.5",  "94.8",  "97.4", 
    "100.0", "103.5", "107.2", "110.9", "114.8", "118.8", 
    "123.0", "127.3", "131.8", "136.5", "141.3", "146.2", 
    "151.4", "156.7", "162.2", "167.9", "173.8", "179.9", 
    "186.2", "192.8", "203.5", "210.7", "218.1", "225.7", 
    "233.6", "241.8", "250.3"
};

char *dcs_tbl[104] =
  {
     "023", "025", "026", "031", "032", 
     "036", "043", "047", "051", "053", 
     "054", "065", "071", "072", "073", 
     "074", "114", "115", "116", "122", 
     "125", "131", "132", "134", "143", 
     "145", "152", "155", "156", "162", 
     "165", "172", "174", "205", "212", 
     "223", "225", "226", "243", "244", 
     "245", "246", "251", "252", "255", 
     "261", "263", "265", "266", "271", 
     "274", "306", "311", "315", "325", 
     "331", "332", "343", "346", "351", 
     "356", "364", "365", "371", "411", 
     "412", "413", "423", "431", "432", 
     "445", "446", "452", "545", "455", 
     "462", "464", "465", "466", "503", 
     "506", "516", "523", "526", "532", 
     "546", "565", "606", "612", "624", 
     "627", "631", "632", "654", "662", 
     "664", "703", "712", "723", "731", 
     "732", "734", "743", "754"
  }; 


/* 
 * set tone via ctcss freq 
 * 
 */ 
int ft100_set_ctcss(int fdSer, char *tone)   
{
   int i,j;
   FT100_CMD ft100_cmd;
   ft100_cmd.opcode=SET_CTCSS_TONE;
   if (strlen(tone) == 2) 
      return(ft100_set_ctcss_pl(fdSer, tone)); 
   else 
     {
     j= -1;	
     for(i=0; i< 38; i++) 
       {
	  if(strcmp(tone, tone_tbl[i]) ==0)
	    j=i;
       }
     }
   
   if (j > -1)
      ft100_cmd.p1=(char)j;
   else
      return(-1);     
   
   ft100_cmd.p2=ft100_cmd.p1;
   ft100_cmd.p3=ft100_cmd.p1;
   ft100_cmd.p4=ft100_cmd.p1;
   return(put_ft100_cmd(fdSer, &ft100_cmd));
}


/* 
 * set tone via pl code
 * 
 */ 
int ft100_set_ctcss_pl(int fdSer, char *tone)   
{
   FT100_CMD ft100_cmd;
   ft100_cmd.opcode=SET_CTCSS_TONE;
   
   if (strcasecmp(tone,"XZ")==0) return(ft100_set_ctcss(fdSer,"67.0"));  else
   if (strcasecmp(tone,"4Z")==0) return(ft100_set_ctcss(fdSer,"136.5")); else
   if (strcasecmp(tone,"WZ")==0) return(ft100_set_ctcss(fdSer,"69.3"));  else
   if (strcasecmp(tone,"4A")==0) return(ft100_set_ctcss(fdSer,"141.3")); else
   if (strcasecmp(tone,"XA")==0) return(ft100_set_ctcss(fdSer,"71.9"));  else
   if (strcasecmp(tone,"4B")==0) return(ft100_set_ctcss(fdSer,"146.2")); else
   if (strcasecmp(tone,"WA")==0) return(ft100_set_ctcss(fdSer,"74.4"));  else
   if (strcasecmp(tone,"5Z")==0) return(ft100_set_ctcss(fdSer,"151.4")); else
   if (strcasecmp(tone,"XB")==0) return(ft100_set_ctcss(fdSer,"77.0"));  else
   if (strcasecmp(tone,"5A")==0) return(ft100_set_ctcss(fdSer,"156.7")); else
   if (strcasecmp(tone,"WB")==0) return(ft100_set_ctcss(fdSer,"79.7"));  else
   if (strcasecmp(tone,"5B")==0) return(ft100_set_ctcss(fdSer,"162.2")); else
   if (strcasecmp(tone,"YZ")==0) return(ft100_set_ctcss(fdSer,"82.5"));  else
   if (strcasecmp(tone,"6Z")==0) return(ft100_set_ctcss(fdSer,"167.9")); else
   if (strcasecmp(tone,"YA")==0) return(ft100_set_ctcss(fdSer,"85.4"));  else
   if (strcasecmp(tone,"6A")==0) return(ft100_set_ctcss(fdSer,"173.8")); else
   if (strcasecmp(tone,"YB")==0) return(ft100_set_ctcss(fdSer,"88.5"));  else
   if (strcasecmp(tone,"6B")==0) return(ft100_set_ctcss(fdSer,"179.9")); else
   if (strcasecmp(tone,"ZZ")==0) return(ft100_set_ctcss(fdSer,"91.5"));  else
   if (strcasecmp(tone,"7Z")==0) return(ft100_set_ctcss(fdSer,"186.2")); else
   if (strcasecmp(tone,"ZA")==0) return(ft100_set_ctcss(fdSer,"94.8"));  else
   if (strcasecmp(tone,"7A")==0) return(ft100_set_ctcss(fdSer,"192.8")); else
   if (strcasecmp(tone,"ZB")==0) return(ft100_set_ctcss(fdSer,"97.4"));  else
   if (strcasecmp(tone,"M1")==0) return(ft100_set_ctcss(fdSer,"203.5")); else
   if (strcasecmp(tone,"1Z")==0) return(ft100_set_ctcss(fdSer,"100.0")); else
   if (strcasecmp(tone,"8Z")==0) return(ft100_set_ctcss(fdSer,"206.5")); else
   if (strcasecmp(tone,"1A")==0) return(ft100_set_ctcss(fdSer,"103.5")); else
   if (strcasecmp(tone,"M2")==0) return(ft100_set_ctcss(fdSer,"210.7")); else
   if (strcasecmp(tone,"1B")==0) return(ft100_set_ctcss(fdSer,"107.2")); else
   if (strcasecmp(tone,"M3")==0) return(ft100_set_ctcss(fdSer,"218.1")); else
   if (strcasecmp(tone,"2Z")==0) return(ft100_set_ctcss(fdSer,"110.9")); else
   if (strcasecmp(tone,"M5")==0) return(ft100_set_ctcss(fdSer,"223.6")); else
   if (strcasecmp(tone,"2A")==0) return(ft100_set_ctcss(fdSer,"114.8")); else
   if (strcasecmp(tone,"M4")==0) return(ft100_set_ctcss(fdSer,"225.7")); else
   if (strcasecmp(tone,"2B")==0) return(ft100_set_ctcss(fdSer,"118.8")); else
   if (strcasecmp(tone,"9Z")==0) return(ft100_set_ctcss(fdSer,"229.1")); else
   if (strcasecmp(tone,"3Z")==0) return(ft100_set_ctcss(fdSer,"123.0")); else
   if (strcasecmp(tone,"M6")==0) return(ft100_set_ctcss(fdSer,"241.8")); else
   if (strcasecmp(tone,"3A")==0) return(ft100_set_ctcss(fdSer,"127.3")); else
   if (strcasecmp(tone,"M7")==0) return(ft100_set_ctcss(fdSer,"250.3")); else
   if (strcasecmp(tone,"3B")==0) return(ft100_set_ctcss(fdSer,"131.8")); else

     return(-1);   
}
   
/* simple function to set dcs code */
   
int ft100_set_dcs(int fdSer, char *code)   
{  
   int i,j;
   FT100_CMD ft100_cmd;
   ft100_cmd.opcode=SET_DCS_CODE;
   
   j= -1;	
   for(i=0; i< 103; i++) 
      {
	if(strcmp(code, dcs_tbl[i]) ==0)
	  j=i;
      }

   
   if (j > -1)
      ft100_cmd.p1=(char)j;
   else
      return(-1);        
   
   ft100_cmd.p2=ft100_cmd.p1;
   ft100_cmd.p3=ft100_cmd.p1;
   ft100_cmd.p4=ft100_cmd.p1;
   return(put_ft100_cmd(fdSer, &ft100_cmd));
}

 

int ft100_set_dcs_ctcss_mode(int fdSer, char *mode)
{
   FT100_CMD ft100_cmd;
   ft100_cmd.opcode=SET_CTCSS_DCS_MODE;
   
   if (strcasecmp(mode, "OFF")==0) ft100_cmd.p1=CTCSS_DCS_OFF; else
   if (strcasecmp(mode, "ENC")==0) ft100_cmd.p1=CTCSS_ENC_ON; else
   if (strcasecmp(mode, "TENC")==0) ft100_cmd.p1=CTCSS_TENC_DEC_ON; else
   if (strcasecmp(mode, "TSQ")==0) ft100_cmd.p1=CTCSS_TENC_DEC_ON; else
   if (strcasecmp(mode, "DCS")==0) ft100_cmd.p1=DCS_ON; else
      return(-1);
      
   ft100_cmd.p2=ft100_cmd.p1;
   ft100_cmd.p3=ft100_cmd.p1;
   ft100_cmd.p4=ft100_cmd.p1;   
   return(put_ft100_cmd(fdSer, &ft100_cmd));
}

char *cnvrt_tone(int tone_idx)
{
   // printf("-- %s -- \n",tone_tbl[tone_idx]);
   return(tone_tbl[tone_idx]);
}

char *cnvrt_dcs(int tone_idx)
{
   // printf("-- %s -- \n",tone_tbl[tone_idx]);
   return(dcs_tbl[tone_idx]);
}


